package categoryservicelogic

import (
	"context"

	"code.30cm.net/digimon/app-cloudep-product-service/gen_result/pb/product"
	"code.30cm.net/digimon/app-cloudep-product-service/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetLogic {
	return &GetLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// Get 取得 product 分類
func (l *GetLogic) Get(in *product.CategoryReq) (*product.Category, error) {
	category, err := l.svcCtx.CategoryUseCase.FindOneByID(l.ctx, in.GetId())
	if err != nil {
		return nil, err
	}

	return &product.Category{
		Id:         category.ID.Hex(),
		Name:       category.Name,
		CreateTime: category.CreatedAt,
		UpdateTime: category.UpdatedAt,
	}, nil
}
