package tagservicelogic

import (
	"context"

	"code.30cm.net/digimon/app-cloudep-product-service/gen_result/pb/product"
	"code.30cm.net/digimon/app-cloudep-product-service/internal/svc"

	"github.com/zeromicro/go-zero/core/logx"
)

type DeleteLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewDeleteLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DeleteLogic {
	return &DeleteLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

// Delete 刪除tags
func (l *DeleteLogic) Delete(in *product.TagsReq) (*product.OKResp, error) {
	err := l.svcCtx.TagsUseCase.Delete(l.ctx, in.GetId())
	if err != nil {
		return nil, err
	}

	return &product.OKResp{}, nil
}
