package product

type ItemType int8

const (
	ItemTypeUnknown ItemType = iota // 未知
	ItemTypeNormal                  // 普通 tag
	ItemTypeSkill                   // 技能專用 tag
	ItemTypeProduct                 // 專案用
)

func (t *ItemType) ToString() string {
	s, _ := ItemTypeToString(*t)
	return s
}

const (
	ItemTypeUnknownStr = "unknown"
	ItemTypeNormalStr  = "normal"
	ItemTypeSkillStr   = "skill"
	ItemTypeProductStr = "product"
)

var itemTypeToStringMap = map[ItemType]string{
	ItemTypeUnknown: ItemTypeUnknownStr,
	ItemTypeNormal:  ItemTypeNormalStr,
	ItemTypeSkill:   ItemTypeSkillStr,
	ItemTypeProduct: ItemTypeProductStr,
}

var stringToItemTypeMap = map[string]ItemType{
	ItemTypeUnknownStr: ItemTypeUnknown,
	ItemTypeNormalStr:  ItemTypeNormal,
	ItemTypeSkillStr:   ItemTypeSkill,
	ItemTypeProductStr: ItemTypeProduct,
}

// ItemTypeToString 將 ItemType 轉換為字串
func ItemTypeToString(it ItemType) (string, bool) {
	str, ok := itemTypeToStringMap[it]
	return str, ok
}

// StringToItemType 將字串轉換為 ItemType
func StringToItemType(str string) (ItemType, bool) {
	it, ok := stringToItemTypeMap[str]
	return it, ok
}
