package product

type ShowType int64

const (
	ShowTypeNormal ShowType = iota // 沒有任何外匡
)

func (s *ShowType) ToString() string {
	str, _ := ShowTypeToString(*s)
	return str
}

const (
	ShowTypeNormalStr = "normal"
)

var showTypeToStringMap = map[ShowType]string{
	ShowTypeNormal: ShowTypeNormalStr,
}

var stringToShowTypeMap = map[string]ShowType{
	ShowTypeNormalStr: ShowTypeNormal,
}

// ShowTypeToString 將 ShowType 轉換為字串
func ShowTypeToString(st ShowType) (string, bool) {
	str, ok := showTypeToStringMap[st]
	return str, ok
}

// StringToShowType 將字串轉換為 ShowType
func StringToShowType(str string) (ShowType, bool) {
	st, ok := stringToShowTypeMap[str]
	return st, ok
}
